﻿-- Author      : Olivier
-- Create Date : 3/3/2012 12:52:24 PM

local AddOns_name = "EveryGoldToBanker";

receiver = "No receiver";
amount = 100;
EveryGoldToBanker_Config = {receiver,amount};



function EveryGoldToBankerCalculator_OnLoad()
	EveryGoldToBankerCalculator:RegisterEvent("PLAYER_ENTERING_WORLD");
	EveryGoldToBankerCalculator:RegisterEvent("MAIL_SHOW");
	EveryGoldToBankerCalculator:RegisterEvent("MAIL_CLOSED");
	EveryGoldToBankerCalculator:RegisterEvent("ADDON_LOADED");
	EveryGoldToBankerCalculator:RegisterEvent("PLAYER_LOGOUT");	
	EveryGoldToBankerCalculator:RegisterForDrag("LeftButton");
	EveryGoldToBankerCalculator:Hide();
end

function EveryGoldToBankerCalculator_OnEvent(frame, event, firstArg, secondArg)
	if (event == "PLAYER_ENTERING_WORLD") then		
		SettingFrame:Hide();
	elseif (event == "MAIL_SHOW") then
		EveryGoldToBankerCalculator:Show();
		AmountEditBox:SetNumber(EveryGoldToBanker_Config[2]);
		ReceiverEditBox:SetText(EveryGoldToBanker_Config[1]);
		DefaultAmountEditBox:SetNumber(EveryGoldToBanker_Config[2]);
		DefaultReceiverEditBox:SetText(EveryGoldToBanker_Config[1]);
	elseif (event == "MAIL_CLOSED") then
		EveryGoldToBankerCalculator:Hide();
	elseif (event == "ADDON_LOADED") then
		if (firstArg == AddOns_name) then
			print("EveryGoldToBanker loaded!");
		end
	end
end

function EveryGoldToBankerCalculator_OnDragStart()
	EveryGoldToBankerCalculator:StartMoving();
end

function EveryGoldToBankerCalculator_OnDragStop()
	EveryGoldToBankerCalculator:StopMovingOrSizing();
end

function CheckButton_OnClick()
	amountToSend = CalculateGoldToSend();
	amountToSendConverted = Convert(amountToSend);
	
	AmountToSend:SetText("You have to send \n " .. amountToSendConverted);
end

function SendButton_OnClick()
	tempReceiver = ReceiverEditBox:GetText();
	amountToSend = CalculateGoldToSend();
	amountToSendConverted = Convert(amountToSend);
	
	if (tempReceiver ~= "No receiver") then
		SetSendMailMoney(amountToSend);
		SendMail(tempReceiver,"EveryMoneyToBanker auto-send system.","");
	else
		AmountToSend:SetText("You didn't change the receiver name. CHANGE IT!");
	end
end

function SettingButton_OnClick()
	if(SettingFrame:IsVisible()) then
		SettingFrame:Hide();
	else
		SettingFrame:Show();
	end
end

function DoneSettingButton_OnClick()
	defaultReceiver = DefaultReceiverEditBox:GetText();
	defaultAmount = DefaultAmountEditBox:GetText();
	EveryGoldToBanker_Config = {defaultReceiver, defaultAmount};
	
	AmountEditBox:SetNumber(defaultAmount);
	ReceiverEditBox:SetText(defaultReceiver);
	
	SettingFrame:Hide();
end

function Convert(amount)
	amountString = "" .. amount
	length = strlen(amountString)
	
	copper = "" .. strsub(amountString,length-1,length)
	silver = "" .. strsub(amountString,length-3,length-2)
	gold = "" .. strsub(amountString,length-(length-1),length-4)
	
	amountConverted = "" .. gold .. " g. " .. silver .. " s. " .. copper .. " c."
	
	return amountConverted
end

function CalculateGoldToSend()
	amountToKeep = AmountEditBox:GetNumber()*10000
	amountInBag = GetMoney()
	sendPrice = GetSendMailPrice()
	
	amountToSend = amountInBag-amountToKeep-sendPrice
	
	return amountToSend
end